/*
1. Defina uma estrutura para armazenar pontos do R2.
2. Defina uma funo que receba dois pontos, por valor, e retorne
   um ponto em que as coordenadas sejam a soma das coordenadas
   passadas como parmetro.
3. Defina uma funo que receba por parametro, um ponto, e altere
   suas coordenadas para que distem de apenas uma unidade da origem
   do r2, isto , assuma que o ponto indica um vetor saindo da
   origem e normalize-o. O comprimento de um vetor  igual  raiz
   quadrada da soma dos quadrados de suas componentes, e o vetor
   pode ser normalizado dividindo-se cada uma de suas componentes
   pelo comprimento do vetor.
4. Crie uma outra funo que faa o mesmo que a funo anterior,
   mas para um vetor de estruturas em vez de apenas uma.
*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

typedef struct pto ponto;
struct pto {
    float x;
    float y;
};

ponto soma(ponto a, ponto b)
{
    ponto c;

    c.x = a.x + b.x;
    c.y = a.y + b.y;

    return c;
}

ponto normalizaPonto(ponto p)
{
    float aux;

    aux = sqrt( (p.x)*(p.x) + (p.y)*(p.y) );
    p.x = p.x/aux;
    p.y = p.y/aux;

    return p;
}

void normalizaPontos(ponto p[], int n)
{
    float aux;
    int i;

    for(i = 0; i < n; i++)
    {
        aux = sqrt( (p[i].x)*(p[i].x) + (p[i].y)*(p[i].y) );
        p[i].x = p[i].x/aux;
        p[i].y = p[i].y/aux;
    }

}


int main()
{
    ponto a, b, c, pontos[5];
    int i;

    a.x = 1;
    a.y = 1;
    b.x = 2;
    b.y = 2;

    printf("\nPonto a: ");
    printf("x = %f  y = %f\n", a.x, a.y);
    printf("\nPonto b: ");
    printf("x = %f  y = %f\n", b.x, b.y);

    printf("\nsomaPonto a e b:  ");
    c = soma(a, b);
    printf("x = %f  y = %f\n", c.x, c.y);

    a = normalizaPonto(a);
    printf("\nnormalizaPonto a:  ");
    printf("x = %f  y = %f\n", a.x, a.y);

    b = normalizaPonto(b);
    printf("\nnormalizaPonto b:  ");
    printf("x = %f  y = %f\n", b.x, b.y);

    printf("\n");
    for(i = 0; i < 5; i++)
    {
        pontos[i].x = i;
        pontos[i].y = i+1;
    }
    normalizaPontos(pontos, 5);
    for(i = 0; i < 5; i++)
    {
        printf("x = %f  y = %f\n", pontos[i].x, pontos[i].y);
    }

    printf("\n");
    for(i = 0; i < 5; i++)
    {
        pontos[i].x = i+1;
        pontos[i].y = i;
    }
    normalizaPontos(pontos, 5);
    for(i = 0; i < 5; i++)
    {
        printf("x = %f  y = %f\n", pontos[i].x, pontos[i].y);
    }

    return 0;
}
